SystemOrganization addCategory: #'tODE-Metacello'!

!TOHome methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 14:20'!
renderMetacelloHomeViewContentOn: html spec: aTOTabSpec main: main
	<tODEHomeView>
	| projectList |
	projectList := self properties
		at: #metacelloProjectList
		ifAbsent: [ self properties at: #metacelloProjectList put: (TOConfigurationList new frame: self frame) ].
	projectList resetSearch.
	html strong: 'Projects ('.
	self
		renderLink: [ :s | 
			projectList showDetails: projectList showDetails not.
			main updateCenterSideHistory: s ]
		with: [ 
			projectList showDetails
				ifTrue: [ html text: 'names' ]
				ifFalse: [ html text: 'details' ] ]
		on: html.
	html strong: '):'.
	html unorderedList: [ projectList renderViewContentOn: html main: main ]! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 09:50'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		renderer:
				((TOPackageClassList new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 11:11'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: ((TOPackage new)
			mbPackageInfo: self;
			yourself);  
		sidebarSpec: self tODEViewSidebarSpec;
		yourself! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:52'!
todeCssClass
	|  wc loadedPkgName cssSpanClass |
	(wc := self workingCopy) isNil
		ifTrue: [ ^ super todeCssClass ].
	cssSpanClass := ''.
	wc ancestry ancestors notEmpty
		ifTrue: [ 
			loadedPkgName := wc ancestry ancestors first name.
			loadedPkgName = self name
				ifFalse: [ 
					(self compareWorkingCopyNamed: loadedPkgName using: #<=)
						ifTrue: [ cssSpanClass := 'outofspec ' ].
					cssSpanClass := cssSpanClass , 'mismatch ' ] ].
	self isDirty
		ifTrue: [ cssSpanClass := cssSpanClass , 'dirty ' ].
	^cssSpanClass! !

!MBBaselineInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 17:42'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer:
				((TOBaselineVersion new)
						mbVersionInfo: self;
						yourself);
		yourself! !

!MBPackageHistoryCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 19:47'!
istODECommand

	^true! !

!MBPackageHistoryCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 09:43'!
renderCommandOn: html for: aTOMetacelloView main: main
	| wc |
	wc := target spec workingCopy ifNil: [ ^ self ].
	wc ancestors isEmpty
		ifTrue: [ ^ self ].
	(html submitButton)
		onClick:
				(html jQuery ajax
						script: [ :s | 
							| infos ancestry |
							ancestry := wc ancestors first.
							infos := (TOCollection new)
								label: 'History for ' , target name;
								collection: ancestry withBreadthFirstAncestors;
								selectedTab: #view;
								printStringBlock: [ :item | item name , ' (' , item date asString , ', ' , item time asString , ')' ];
								itemRenderBlock: [ :item :r :m | r preformatted: item summary ];
								yourself.
							aTOMetacelloView currentSession push: infos selecting: #view.
							main updateCenterSideHistory: s ]);
		with: 'history'! !

!MBCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^false! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/11/2011 17:55'!
renderCommandOn: html for: aTOMetacelloView main: main
	aTOMetacelloView
		renderButton: [ :s | 
			self execute.
			main updateCenterSideHistory: s ]
		label: self todeTitle
		on: html! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:39'!
todeTitle

	^self title! !

!MBVersionInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 16:56'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer:
				((TOVersion new)
						mbVersionInfo: self;
						yourself);
		yourself! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 08:08'!
configurationQueryResults
	<todeSearch: 'Configurations' selector: #configurationSearch priority: 35>
	^ (MBConfigurationRoot current configurations select: [ :ci | ci name includesSubstring: searchText caseSensitive: false ]) sorted: [ :a :b | a name <= b name ]! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 07:42'!
packageQueryResults
	<todeSearch: 'Packages' selector: #packageSearch priority: 30>
	^ (MCWorkingCopy allManagers select: [ :wc | wc packageName includesSubstring: searchText caseSensitive: false ])
		sorted: [ :a :b | a packageName <= b packageName ]! !

!MCWorkingCopy methodsFor: '*tode-metacello' stamp: 'dkh 6/15/2011 16:08'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		renderer: ((TOWorkingCopy new)
			workingCopy: self;
			yourself);  
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		renderSelector: #renderViewContentOn:spec:main:! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 5/8/2011 08:29'!
baselineInfoFor: aVersionString

	^self baselines detect: [:each | each versionString = aVersionString ]! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/22/2011 11:24'!
renderCommandsOn: html for: aTOMetacelloView main: main
	super renderCommandsOn: html for: aTOMetacelloView main: main! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 17:22'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewConfigurationClasses;
		renderer:
				((TOConfigurationSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'configuration view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 11:24'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: ((TOConfiguration new)
			mbConfigurationInfo: self;
			yourself);  
		sidebarSpec: self tODEViewSidebarSpec;
		yourself! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:59'!
todeCssClass
	| cv specVersion wc cssSpanClass |
	[ 
	cssSpanClass := ''.
	((wc := self workingCopy) notNil and: [ wc needsSaving ])
		ifTrue: [ cssSpanClass := 'dirty ' ].
	self isDirty
		ifTrue: [ cssSpanClass := 'contentsdirty ' , cssSpanClass ].
	self currentVersion.	"prime the pump"
	currentVersion == #notLoaded
		ifTrue: [ ^ cssSpanClass ].
	super isDirty | self currentVersionMismatch
		ifTrue: [ cssSpanClass := 'mismatch ' , cssSpanClass ].
	self currentVersion versionStatus == #somethingLoaded
		ifTrue: [ cssSpanClass := cssSpanClass , 'somethingloaded ' ].
	^ cssSpanClass ] on: Error do: [ :ex | ^ 'error' ]! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 21:23'!
versionInfoFor: aVersionString

	^self versions detect: [:each | each versionString = aVersionString ]! !

!TextDiffBuilder methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 14:36'!
renderContentOn: html view: aTOPatch main: main
	| lineEndings |
	lineEndings := String cr , String lf.
	(html div)
		class: 'naviode';
		with: [ 
					html
						preformatted: [ 
							self
								patchSequenceDoIfMatch: [ :string | html text: string; break ]
								ifInsert: [ :string | 
									(html span)
										class: 'insert';
										with: [ html text: string; break ] ]
								ifRemove: [ :string | 
									(html span)
										class: 'remove';
										with: [ html text: string; break ] ] ] ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/22/2011 11:00'!
renderCommandsOn: html for: aTOMetacelloView main: main
	| commands |
	commands := ((self commands select: [ :each | each istODECommand ])
		collect: [ :commandClass | commandClass target: self for: nil ]) asArray sort: [ :a :b | a order <= b order ].
	commands isEmpty
		ifTrue: [ ^ self ].
	commands do: [ :command | 
		command renderCommandOn: html for: aTOMetacelloView main: main.
		html break ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 12:46'!
renderFrameTitleOn: html main: main
	| cl |
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html div)
		class: 'naviode';
		with: [ 
					self renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 21:13'!
renderLabelOn: html main: main
	(html div)
		class: 'naviode';
		with: [ self renderStyledLabelOn: html main: main ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 10:00'!
renderStyledLabelOn: html main: main
	(html span)
		class: self todeCssClass;
		with: [ html text: self printString ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:52'!
todeCssClass
	^ 'default'! !

TOView subclass: #TOAbstractVersion
	instanceVariableNames: 'mbVersionInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/23/2011 16:48'!
mbVersionInfo
	^ mbVersionInfo! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/23/2011 16:48'!
mbVersionInfo: anMBVersionInfo
	mbVersionInfo := anMBVersionInfo! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/23/2011 17:44'!
renderInfoLabel: info on: html main: main
	info renderLabelOn: html main: main! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/24/2011 11:15'!
renderViewContentOn: html main: main
	super renderViewContentOn: html main: main! !

TOAbstractVersion subclass: #TOBaselineVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOBaselineVersion methodsFor: 'rendering' stamp: 'dkh 6/23/2011 17:49'!
renderInfoLabel: info on: html main: main
	html text: info name.
	html break! !

TOAbstractVersion subclass: #TOVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOView subclass: #TOConfiguration
	instanceVariableNames: 'mbConfigurationInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/22/2011 10:01'!
classList
	| cv |
	self mbConfigurationInfo ifNil: [ ^ #() ].
	(cv := self mbConfigurationInfo currentVersion) ifNil: [ ^ #() ].
	^ cv currentlyLoadedClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/22/2011 10:09'!
extensionClassList
	| cv |
	self mbConfigurationInfo ifNil: [ ^ Dictionary new ].
	(cv := self mbConfigurationInfo currentVersion) ifNil: [ ^ Dictionary new ].
	^ cv  currentlyLoadedExtensionClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:33'!
mbConfigurationInfo
	mbConfigurationInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbConfigurationInfo := config.
									^ config ] ] ] ].
	^ mbConfigurationInfo! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:06'!
mbConfigurationInfo: anObject
	mbConfigurationInfo := anObject! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/21/2011 21:20'!
nextBaselineVersion
	| latestVersion |
	latestVersion := self mbConfigurationInfo project latestVersion: #baseline.
	latestVersion ifNil: [ ^ '0.1-baseline' ].
	^ latestVersion versionNumber incrementMinorVersionNumber versionString! !

!TOConfiguration methodsFor: 'printing' stamp: 'dkh 6/17/2011 04:37'!
printOn: aStream

super printOn: aStream.
aStream nextPut: $(;
nextPutAll: self mbConfigurationInfo printString;
nextPut: $)! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/24/2011 09:27'!
renderAddBaselineCommandOn: html main: main
	| exampleText |
	exampleText := self nextBaselineVersion.
	self
		renderVersionCommand: [ :s :versionString | 
			| configurationInfo baselineVersionString |
			baselineVersionString := versionString ifNil: [ exampleText ].
			configurationInfo := self mbConfigurationInfo.
			(MetacelloToolBox configurationNamed: configurationInfo configurationClass name)
				createVersionMethod: 'baseline' , (MetacelloToolBox stripVersionStringForSelector: baselineVersionString) , ':'
					inCategory: 'baselines'
					forVersion: baselineVersionString;
				addSection: #common
					repository: nil
					requiredProjects: #()
					packages: #()
					dependencies: #()
					groups: #()
					versionSpecsDo: [ :versionSpec | versionSpec blessing: #baseline ];
				commitMethod.
			self pushit: (configurationInfo baselineInfoFor: baselineVersionString) selecting: #view main: main ]
		exampleText: exampleText
		label: 'add baseline'
		on: html
		main: main! !

!TOConfiguration methodsFor: 'rendering-add package' stamp: 'dkh 6/24/2011 09:37'!
renderAddPackageCommandOn: html main: main
	| exampleText packageName id |
	exampleText := ' new packageName'.
	(html textInput)
		id: (id := html nextId);
		exampleText: exampleText;
		value: packageName;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | packageName := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: packageName) ]);
		onChange: (html jQuery ajax callback: [ :value | packageName := value ] value: (html jQuery id: id) value).
	html space.
	self
		renderButton: [ :s | 
			main updateCenterOn: s ]
		label: 'add package'
		on: html! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/24/2011 09:27'!
renderAddVersionCommandOn: html main: main
	| exampleText |
	exampleText := '0.1'.
	self
		renderVersionCommand: [ :s :versionString | self pushit: (versionString ifNil: [ exampleText ]) selecting: #view main: main ]
		exampleText: exampleText
		label: 'add version'
		on: html
		main: main! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:40'!
renderCommandsOn: html main: main
	self renderAddBaselineCommandOn: html main: main.
	self mbConfigurationInfo baselines notEmpty
		ifTrue: [ 
			html break.
			self renderAddVersionCommandOn: html main: main ].
	html break.
	self renderAddPackageCommandOn: html main: main.
	self mbConfigurationInfo packages notEmpty
		ifTrue: [ 
			html break.
			self renderPackageChangesCommandOn: html main: main ]! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:25'!
renderContentOn: html main: main
	self mbConfigurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	self renderCommandsOn: html main: main.
	html break.
	self mbConfigurationInfo renderCommandsOn: html for: self main: main! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/24/2011 12:45'!
renderFrameTitleOn: html main: main
	| cl |
	self mbConfigurationInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html div)
		class: 'naviode';
		with: [ 
					self mbConfigurationInfo renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!TOConfiguration methodsFor: 'rendering-package changes' stamp: 'dkh 6/24/2011 09:26'!
renderPackageChangesCommandOn: html main: main
	| wc |
	self
		renderButton: [ :s | 
			| patches searchResults nameMap count parentCollection linkedItems |
			patches := OrderedCollection new.
			nameMap := IdentityDictionary new.
			(self mbConfigurationInfo packages
				select: [ :mbPackageInfo | (wc := mbPackageInfo workingCopy) notNil and: [ wc ancestors notEmpty and: [ wc modified ] ] ])
				do: [ :mbPackageInfo | 
					| repos names selectedName patch |
					wc := mbPackageInfo workingCopy.
					repos := wc repositoryGroup repositories.
					names := repos collect: [ :r | r description ].
					selectedName := names first.
					patch := wc changesRelativeToRepository: (repos at: (names indexOf: selectedName)).
					nameMap
						at: patch
						put: 'Changes for ' , mbPackageInfo printString , ' (' , patch operations size printString , ' changes)'.
					patches add: patch ].
			linkedItems := OrderedCollection new.
			parentCollection := (TOCollection new)
				directItemLink: true;
				collection: linkedItems;
				printStringBlock: [ :item | item itemLabel ];
				label: 'Changes for: ' , self mbConfigurationInfo printString.
			count := 0.
			searchResults := self
				linkedItemsFor: patches
				withViewerDo: [ :item :viewer | 
					count := count + 1.
					viewer
						parent: parentCollection;
						parentLabel: parentCollection label;
						label: count printString , ' of ' , patches size printString;
						itemLabel: (nameMap at: item).
					linkedItems add: viewer ].
			self currentSession push: searchResults selecting: #view.
			main updateCenterSideHistory: s ]
		label: 'package changes'
		on: html! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/24/2011 09:34'!
renderVersionCommand: commandBlock exampleText: exampleText label: label on: html main: main
	| versionString id |
	(html textInput)
		id: (id := html nextId);
		exampleText: exampleText;
		value: versionString;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | versionString := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									commandBlock value: s value: versionString.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: versionString) ]);
		onChange: (html jQuery ajax callback: [ :value | versionString := value ] value: (html jQuery id: id) value).
	html space.
	self
		renderButton: [ :s | 
			commandBlock value: s value: versionString.
			main updateCenterOn: s ]
		label: label
		on: html! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/16/2011 10:13'!
renderViewContentOn: html main: main

	self renderContentOn: html main: main
! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/23/2011 17:22'!
tODEConfigurationViewSidebarSpec
	^ {((TOTabSpec new)
		id: #configurationViewClasses;
		renderer: ((TOConfigurationSidebar new) specLabel: #view; yourself);
		receiver: self;
		label: 'configuration view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/16/2011 11:20'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: self;
		sidebarSpec: self tODEConfigurationViewSidebarSpec;
		yourself! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:07'!
workingCopy

	^self mbConfigurationInfo workingCopy  ! !

TOView subclass: #TOConfigurationList
	instanceVariableNames: 'configurationSearchResults advancedSearch showDetails repositoryMap searchTerm selectedRepositoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfigurationList methodsFor: 'create' stamp: 'dkh 6/21/2011 19:29'!
doCreate: projectName main: main
	| configurationClassName |
	configurationClassName := 'ConfigurationOf' , projectName.
	Smalltalk globals
		at: configurationClassName asSymbol
		ifPresent: [ :ex | ^ self pushit: 'Class ' , configurationClassName printString , ' already exists.' selecting: #view main: main ].
	MetacelloToolBox new createConfiguration: projectName.
	self
		pushit: (MBConfigurationRoot current configurationInfoFor: (Smalltalk at: configurationClassName asSymbol))
		selecting: #view
		main: main! !

!TOConfigurationList methodsFor: 'find' stamp: 'dkh 6/21/2011 16:20'!
doSearch: term main: main
	| map searchResults |
	map := self repositoryMapFor: self selectedRepositoryName.
	searchResults := (map keys select: [ :each | each includesSubstring: term caseSensitive: false ]) sorted.
	advancedSearch := nil.
	configurationSearchResults := searchResults collect: [ :name | (map at: name) first ].
	self
		pushit: self
		selecting: #view
		main: main! !

!TOConfigurationList methodsFor: 'private' stamp: 'dkh 6/21/2011 13:03'!
metacelloConfigurationReferencesFrom: aRepository
	| map |
	map := Dictionary new.
	aRepository goferReferences
		do: [ :ref | 
			(ref packageName beginsWith: 'ConfigurationOf')
				ifTrue: [ 
					| nameWithBranch |
					nameWithBranch := ref metacelloPackageNameWithBranch at: 2.
					nameWithBranch := nameWithBranch copyFrom: 'ConfigurationOf' size + 1 to: nameWithBranch size.
					(map at: nameWithBranch ifAbsent: [ map at: nameWithBranch put: OrderedCollection new ]) add: ref ] ].
	^ map! !

!TOConfigurationList methodsFor: 'rendering-search' stamp: 'dkh 6/21/2011 17:15'!
renderAdvancedSearchResultsOn: html main: main
	| names id |
	configurationSearchResults := nil.
	html strong: 'Advanced Search'.
	html break.
	html break.
	names := (self repositories collect: [ :each | each description ]) sorted.
	(names includes: self selectedRepositoryName)
		ifFalse: [ selectedRepositoryName := names first ].
	html text: 'Use '.
	(html select)
		id: (id := html nextId);
		list: names;
		selected: selectedRepositoryName;
		onChange: (html jQuery ajax callback: [ :value | selectedRepositoryName := value ] value: (html jQuery id: id) value).
	html text: ' to search for '.
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: searchTerm;
		script:
				(html jQuery this autocomplete
						sourceCallback: [ :term | 
							| filtered |
							filtered := (self repositoryMapFor: self selectedRepositoryName) keys.
							filtered := (term = '?'
								ifTrue: [ filtered ]
								ifFalse: [ filtered select: [ :each | each includesSubstring: term caseSensitive: false ] ]) sorted.
							filtered size > 12
								ifTrue: [ filtered := filtered first: 24 ].
							filtered ]);
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: searchTerm) ]);
		onChange: (html jQuery ajax callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s ]);
		with: 'Find'.
	html break.
	html
		unorderedList: [ 
			html
				small: [ 
					html
						emphasis: [ 
							html text: '('.
							html strong: 'Hint: '.
							html text: 'Type a ''?'' to list all project configurations in repository)' ] ] ]! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 6/21/2011 19:11'!
renderCommandsOn: html main: main
	self renderSearchCommandOn: html main: main.
	html break.
	self renderCreateCommandOn: html main: main
! !

!TOConfigurationList methodsFor: 'rendering-create' stamp: 'dkh 6/21/2011 19:14'!
renderCreateCommandOn: html main: main
	| id projectName |
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: projectName;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | projectName := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doCreate: projectName main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: projectName) ]);
		onChange: (html jQuery ajax callback: [ :value | projectName := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | projectName := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doCreate: projectName main: main.
									main updateCenterSideHistory: s ]);
		with: 'Create Project'! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 6/22/2011 11:17'!
renderProjectListOn: html main: main
	(html div)
		class: 'naviode';
		with: [ 
					MBConfigurationRoot current configurations
						do: [ :config | 
							self
								renderLink: [ :s | 
									self currentSession push: config selecting: #view.
									main updateCenterSideHistory: s ]
								with: [ 
									self showDetails
										ifTrue: [ config renderStyledLabelOn: html main: main ]
										ifFalse: [ 
											(html span)
												class: config todeCssClass;
												with: [ html text: (MBToolBox baseNameOf: config name) ] ] ]
								on: html.
							html break ] ]! !

!TOConfigurationList methodsFor: 'rendering-search' stamp: 'dkh 6/21/2011 17:17'!
renderSearchCommandOn: html main: main
	| id |
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: searchTerm;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: searchTerm) ]);
		onChange: (html jQuery ajax callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s ]);
		with: 'Find Project'.
	html space.
	self
		renderLink: [ :s | 
			advancedSearch := true.
			self pushit: self selecting: #view main: main.
			main updateCenterSideHistory: s ]
		with: [ html text: 'advanced search' ]
		on: html.
	html space.
	html
		small: [ 
			html
				emphasis: [ 
					html text: '('.
					html strong: 'Hint:'.
					html text: ' use this command to find and load a project configuration).' ] ]! !

!TOConfigurationList methodsFor: 'rendering-search' stamp: 'dkh 6/21/2011 17:16'!
renderSearchResultsOn: html main: main
	self renderSearchCommandOn: html main: main.
	html break.
	html break.
	configurationSearchResults
		do: [ :resolvedReference | 
			self
				renderLink: [ :s | 
					| loader |
					loader := MCVersionLoader new.
					loader addVersion: resolvedReference version.
					loader loadWithNameLike: 'tODE'.
					self
						pushit: (MBConfigurationRoot current configurationInfoFor: (Smalltalk at: resolvedReference packageName asSymbol))
						selecting: #view
						main: main.
					self resetSearch.
					main updateCenterSideHistory: s ]
				with: [ html text: 'load' ]
				on: html.
			html space.
			html text: resolvedReference name.
			html break ].
	configurationSearchResults size > 20
		ifTrue: [ 
			html break.
			self renderSearchCommandOn: html main: main ]! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 6/21/2011 14:01'!
renderViewContentOn: html main: main
	advancedSearch ifNotNil: [ ^ self renderAdvancedSearchResultsOn: html main: main ].
	configurationSearchResults ifNotNil: [ ^ self renderSearchResultsOn: html main: main ].
	self renderProjectListOn: html main: main.
	html break.
	self renderCommandsOn: html main: main! !

!TOConfigurationList methodsFor: 'private' stamp: 'dkh 6/21/2011 13:20'!
repositories
	^ MCRepositoryGroup default repositories reject: [ :repo | repo = MCCacheRepository default ]! !

!TOConfigurationList methodsFor: 'private' stamp: 'dkh 6/21/2011 13:21'!
repositoryMapFor: selectedRepositoryDescription
	repositoryMap ifNil: [ repositoryMap := Dictionary new ].
	^ repositoryMap
		at: selectedRepositoryDescription
		ifAbsent: [ 
			repositoryMap
				at: selectedRepositoryDescription
				put:
					(self
						metacelloConfigurationReferencesFrom:
							(self repositories detect: [ :repo | repo description = selectedRepositoryDescription ])) ]! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 16:43'!
resetSearch
	selectedRepositoryName := repositoryMap := configurationSearchResults := advancedSearch := nil! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 16:20'!
selectedRepositoryName
	selectedRepositoryName ifNil: [ selectedRepositoryName := 'http://www.squeaksource.com/MetacelloRepository' ].
	^ selectedRepositoryName! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 10:23'!
showDetails
	showDetails ifNil: [ showDetails := false ].
	^ showDetails! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 10:32'!
showDetails: aBool
	showDetails := aBool! !

TOView subclass: #TOPackageClassList
	instanceVariableNames: 'specLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOPackageClassList subclass: #TOConfigurationSidebar
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:22'!
configurationInfo

	^(self frame rendererForCenterTab: self specLabel) mbConfigurationInfo! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:47'!
defaultSpecLabel
	^ #configuration! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 6/13/2011 21:43'!
renderContentOn: html main: main
	| id |
	(html select)
		id: (id := html nextId);
		list: self selectionList;
		selected: self selection;
		callback: [ :index | self selectIndex: index ];
		onChange:
				((html jQuery ajax)
						callback: [ :index | self selectIndex: index ] value: (html jQuery id: id) value;
						script: [ :s | main updateSidebarOn: s ]).
	html break.
	self selection = 'classes'
		ifTrue: [ ^ self renderClassListOn: html main: main ].
	self selection = 'currentVersion'
		ifTrue: [ ^ self renderCurrentVersionOn: html main: main ].
	self selection = 'versions'
		ifTrue: [ ^ self renderVersionListOn: html main: main ]! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:24'!
renderCurrentVersionOn: html main: main
	| cvs list cv |
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	cvs := ''.
	(cv := self configurationInfo currentVersion) ~~ nil
		ifTrue: [ cvs := cv versionString , ' ' ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	(html div)
		class: 'naviode';
		with: [ 
					(list := self configurationInfo projects) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'projects --';
								break.
							list
								do: [ :info | 
									| projectConfig |
									(projectConfig := info projectConfiguration) notNil
										ifTrue: [ 
											self
												renderLink: [ :s | 
													self currentSession push: projectConfig selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ]
										ifFalse: [ 
											info renderLabelOn: html main: main.
											html break ] ].
							html break ].
					(list := self configurationInfo packages) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'packages --';
								break.
							list
								do: [ :info | 
									info workingCopy
										ifNil: [ 
											info renderLabelOn: html main: main.
											html break ]
										ifNotNil: [ 
											self
												renderLink: [ :s | 
													self currentSession push: info selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ] ].
							html break ].
					(list := self configurationInfo groups) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'groups --';
								break.
							list do: [ :info | info renderLabelOn: html main: main ] ] ]! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:24'!
renderVersionListOn: html main: main
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	(html div)
		class: 'naviode';
		with: [ 
					self configurationInfo project
						ifNil: [ 
							^ (html span)
								class: 'error';
								with: 'no project defined' ].
					html
						text: ' -- baselines --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo baselines)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ 
									info renderLabelOn: html main: main.
									html break ] ].
					html
						break;
						text: ' -- versions --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo versions)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ 
									info renderLabelOn: html main: main.
									html break ] ] ]! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:26'!
selectIndex: index

	selection := self selectionList at: index asInteger! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:02'!
selection

	selection ifNil: [ selection := 'currentVersion' ].
	^ selection! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:56'!
selection: anObject
	selection := anObject! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:58'!
selectionList

	^{'classes'. 'currentVersion'. 'versions'. }.
! !

!TOPackageClassList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:47'!
defaultSpecLabel
	^ #package! !

!TOPackageClassList methodsFor: 'rendering' stamp: 'dkh 6/17/2011 10:20'!
renderClassListOn: html main: main
	| order classes indents displayString classList extensionClassList |
	order := SortedCollection
		sortBlock: [ :assoc1 :assoc2 | 
			| result chain1 chain2 max i |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[ result isNil and: [ i <= max ] ]
				whileTrue: [ 
					(chain1 at: i) = (chain2 at: i)
						ifTrue: [ i := i + 1 ]
						ifFalse: [ result := (chain1 at: i) name < (chain2 at: i) name ] ].
			result isNil
				ifTrue: [ chain1 size < chain2 size ]
				ifFalse: [ result ] ].
	classList := (self frame rendererForCenterTab: self specLabel) classList.
	extensionClassList := (self frame rendererForCenterTab: self specLabel) extensionClassList.
	classList
		do: [ :cl | extensionClassList removeKey: cl ifAbsent: []].
	classes :=  classList, extensionClassList keys.
	classes
		do: [ :cl | 
			| supersChain |
			supersChain := cl withAllSuperclasses reversed.
			supersChain removeAllSuchThat: [ :class | (classes includes: class) not ].
			order add: supersChain contents -> cl ].
	indents := IdentityDictionary new.
	order do: [ :assoc | indents at: assoc value put: assoc key size - 1 ].
	classes := classes asArray sorted: [ :a :b | a name <= b name ].
	order
		do: [ :assoc | 
			| cl |
			cl := assoc value.
			(indents at: cl) * 2 timesRepeat: [ html space ].
			self
				renderLink: [ :s | | fr |
					fr := self currentSession push: cl selecting: ((extensionClassList includesKey: cl)
								ifTrue: [#methodSourceBrowser]
								ifFalse: [#classBrowser]).
					(extensionClassList includesKey: cl)
						ifTrue: [| browser selector |
							browser := fr rendererForCenterTab: #methodSourceBrowser.
							selector := (cl organization listAtCategoryNamed: (extensionClassList at: cl) first) first.
							browser methodReference: (SourcedMethodReference class: cl selector: selector) ].
					main updateCenterSideHistory: s ]
				with: [ 
					(extensionClassList includesKey: cl)
								ifTrue: [html text: cl name asString]
								ifFalse: [html strong: cl name asString].
					html break ]
				on: html ]! !

!TOPackageClassList methodsFor: 'rendering' stamp: 'dkh 6/13/2011 20:49'!
renderContentOn: html main: main
	self renderClassListOn: html main: main! !

!TOPackageClassList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:48'!
specLabel
	specLabel ifNil: [ specLabel := self defaultSpecLabel ].
	^ specLabel! !

!TOPackageClassList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:48'!
specLabel: aSymbol
	specLabel := aSymbol ! !

TOView subclass: #TOPatch
	instanceVariableNames: 'selectedOperation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 03:49'!
renderViewContentOn: html main: main

	self selectedOperation ifNil: [html text: 'No operation selected'. ^self].
	self selectedOperation renderContentOn: html view: self main: main  ! !

!TOPatch methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:38'!
selectedOperation
	^ selectedOperation! !

!TOPatch methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:38'!
selectedOperation: anObject
	selectedOperation := anObject! !

TOView subclass: #TOPatchList
	instanceVariableNames: 'mcPatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:24'!
mcPatch
	^ mcPatch! !

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:24'!
mcPatch: anObject
	mcPatch := anObject! !

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:34'!
patchView

	^(self frame rendererForCenterTab: #view)! !

!TOPatchList methodsFor: 'rendering' stamp: 'dkh 6/14/2011 14:19'!
renderContentOn: html main: main
	(html div)
		class: 'naviode';
		with: [ 
					(mcPatch operations sorted: [ :a :b | a summary <= b summary ])
						do: [ :operation | 
							| spanClass |
							spanClass := operation isAddition
								ifTrue: [ 'insert' ]
								ifFalse: [ 
									operation isRemoval
										ifTrue: [ 'remove' ]
										ifFalse: [ 'change' ] ].
							self
								renderLink: [ :s | 
									self patchView selectedOperation: operation.
									main updateCenterSideHistory: s ]
								with: [ 
									(html span)
										class: spanClass;
										with: [ 
													self patchView selectedOperation == operation
														ifTrue: [ html strong: operation summary ]
														ifFalse: [ html text: operation summary ] ] ]
								on: html.
							html break ] ]! !

TOView subclass: #TOWorkingCopy
	instanceVariableNames: 'workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOWorkingCopy subclass: #TOPackage
	instanceVariableNames: 'mbPackageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:32'!
mbPackageInfo
	mbPackageInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbPackageInfo := pkg.
									^ config ] ] ] ].
	^ mbPackageInfo! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 08:18'!
mbPackageInfo: anObject
	mbPackageInfo := anObject! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:49'!
renderAddClassCommandOn: html main: main
	| exampleText className id |
	exampleText := ' new className'.
	(html textInput)
		id: (id := html nextId);
		exampleText: exampleText;
		value: className;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | className := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: className) ]);
		onChange: (html jQuery ajax callback: [ :value | className := value ] value: (html jQuery id: id) value).
	html space.
	self renderButton: [ :s | main updateCenterOn: s ] label: 'add class' on: html! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:47'!
renderCommandsOn: html main: main

	self renderAddClassCommandOn: html main: main.
! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:44'!
renderContentOn: html main: main
	self mbPackageInfo
		ifNil: [ 
			html text: 'No package'.
			^ self ].
	self renderCommandsOn: html main: main.
	html break.
	self mbPackageInfo renderCommandsOn: html for: self main: main! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 12:45'!
renderFrameTitleOn: html main: main
	| cl |
	self mbPackageInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html div)
		class: 'naviode';
		with: [ 
					self mbPackageInfo renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/16/2011 10:12'!
renderViewContentOn: html main: main

	self renderContentOn: html main: main
! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/16/2011 11:17'!
tODEPackageViewSidebarSpec
	^ {((TOTabSpec new)
		id: #packageViewClasses;
		renderer: ((TOPackageClassList new) specLabel: #view; yourself);
		receiver: self;
		label: 'package view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}
! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/16/2011 11:16'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		sidebarSpec: self tODEPackageViewSidebarSpec;
		yourself! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:05'!
workingCopy

	self mbPackageInfo ifNil: [ ^nil ].
	^self mbPackageInfo workingCopy  ! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:06'!
classList
	
	self workingCopy ifNil: [ ^#() ].
	^ self workingCopy packageInfo classes! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:07'!
extensionClassList
	| classes wc |
	classes := Dictionary new.
	(wc := self workingCopy) ifNil: [ ^ classes ].
	wc packageInfo extensionClasses
		do: [ :cl | 
			| cats fullCats |
			cats := wc packageInfo extensionCategoriesForClass: cl.
			fullCats := OrderedCollection new.
			cats
				do: [ :cat | 
					(cl organization listAtCategoryNamed: cat) notEmpty
						ifTrue: [ fullCats add: cat ] ].
			fullCats notEmpty
				ifTrue: [ classes at: cl put: fullCats ] ].
	^ classes! !

!TOWorkingCopy methodsFor: 'rendering' stamp: 'dkh 6/16/2011 03:50'!
renderViewContentOn: html main: main

	html text: 'work in progress ... do I really need this view ... I want to convert to MBPackageInfo or just use regular inspector ... being able to get MBPackageInfo and going from there is probably a good thing'. ! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:03'!
workingCopy
	^workingCopy! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:04'!
workingCopy: aMCWorkingCopy
	workingCopy := aMCWorkingCopy! !

!MCPatchOperation methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 16:50'!
renderContentOn: html view: aTOPatch main: main
	self renderNavigationOn: html view: aTOPatch main: main.
	^ self isClassPatch
		ifTrue: [ (TextDiffBuilder from: self fromSource to: self toSource) renderContentOn: html view: aTOPatch main: main ]
		ifFalse: [ 
			(TextDiffBuilder from: self fromSource to: self toSource inClass: self targetClass)
				renderContentOn: html
				view: aTOPatch
				main: main ]! !

!MCPatchOperation methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 19:03'!
renderNavigationOn: html view: aTOPatch main: main

	| class |
	(class := self targetClass) ifNil: [ ^html strong: self targetClass name asString ].
	aTOPatch
		renderLink: [ :s | 
			main currentSession push: class selecting: #methodClassBrowser.
			main updateCenterSideHistory: s ]
		with: [html strong: class name asString]
		on: html.
	self isClassPatch ifTrue: [ ^self ].
	html text: '>>'.
	aTOPatch
		renderLink: [ :s | | fr selector |
			fr := main currentSession push: class selecting: #methodSourceBrowser.
selector := self definition selector.
(class includesSelector: selector)
  ifTrue: [ 
			(fr rendererForCenterTab: #methodSourceBrowser) methodReference: (MethodReference class: class selector: selector) ].
			main updateCenterSideHistory: s ]
		with: [html strong: self definition selector]
		on: html.
! !

!TOSystem methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 16:06'!
configurationRoot

	^MBConfigurationRoot current! !

!MBRevertPackageCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^true! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 08:36'!
basePackageName
	^ target workingCopy packageName copyUpToLast: #-! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 19:31'!
renderCommandOn: html for: aTOMetacelloView main: main
	| selectedName ancestors ancestorNames id ajax |
	ancestors := target workingCopy ancestry breadthFirstAncestors.
	ancestors isEmpty
		ifTrue: [ ^ self ].
	ancestorNames := ancestors collect: [ :ea | ea name ].
	selectedName := ancestorNames first.
	ajax := html jQuery ajax.
	target workingCopy modified
		ifTrue: [ 
			ajax
				confirm:
					'You are about to load a new version of ' , self basePackageName printString
						, ' that has unsaved changes in the image.  If you continue, you will lose these changes?' ].
	ajax
		script: [ :s | 
			self
				revertPackage: (ancestors at: (ancestorNames indexOf: selectedName))
				for: aTOMetacelloView
				script: s
				main: main ].
	(html submitButton)
		onClick: ajax;
		with: self todeTitle.
	(html select)
		id: (id := html nextId);
		list: ancestorNames;
		selected: selectedName;
		onChange: (html jQuery ajax callback: [ :value | selectedName := value ] value: (html jQuery id: id) value)! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 11:12'!
revertPackage: info for: aTOMetacelloView script: s main: main
	"unconditional loading by the time this method is called ... overrides modified packages."

	[ 
	(target workingCopy repositoryGroup versionWithInfo: info ifNone: [ ^ s alert: 'No repository found for ' , info name ])
		load ] on: Warning do: [ :ex | ex resume: true ].
	s alert: 'Reverted: ' , info name.
	main updateCenterSideHistory: s! !

!MBPackageChangesCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 11:02'!
istODECommand

	^true! !

!MBPackageChangesCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 09:42'!
renderCommandOn: html for: aTOMetacelloView main: main
	| selectedName id wc repos names |
	wc := target spec workingCopy ifNil: [ ^ self ].
	wc ancestors isEmpty
		ifTrue: [ ^ self ].
	repos := wc repositoryGroup repositories.
	names := repos collect: [ :r | r description ].
	selectedName := names first.
	(html submitButton)
		onClick:
				(html jQuery ajax
						script: [ :s | 
							| patch |
							patch := wc changesRelativeToRepository: (repos at: (names indexOf: selectedName)).
							patch
								ifNotNil: [ 
									patch isEmpty
										ifTrue: [ 
											wc modified: false.
											aTOMetacelloView currentSession push: 'No changes' selecting: #view ]
										ifFalse: [ 
											wc modified: true.
											aTOMetacelloView currentSession push: patch selecting: #view ].
									main updateCenterSideHistory: s ] ]);
		with: 'changes'.
	(html select)
		id: (id := html nextId);
		list: names;
		selected: selectedName;
		onChange: (html jQuery ajax callback: [ :value | selectedName := value ] value: (html jQuery id: id) value).
! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 21:02'!
renderMetacelloSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 17:06'!
renderMetacelloTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 17:22'!
tODEConfigurationSidebarSpec
	^ {((TOTabSpec new)
		id: #configurationClasses;
		rendererClass: TOConfigurationSidebar;
		receiver: self;
		label: 'configuration classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:14'!
tODEConfigurationTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #configuration;
		rendererClass: TOConfiguration;
		receiver: self;
		label: 'configuration';
		order: 10;
		group: 'monticello';
		sidebarSpec: self tODEConfigurationSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 20:52'!
tODEPackageSidebarSpec
	^ {((TOTabSpec new)
		id: #packageClasses;
		rendererClass: TOPackageClassList;
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:20'!
tODEPackageTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #package;
		rendererClass: TOPackage;
		receiver: self;
		label: 'package';
		order: 20;
		group: 'monticello';
		sidebarSpec: self tODEPackageSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !

!MetacelloSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 09:52'!
renderViewContentOn: html main: main
	html preformatted: self printString
! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 12:28'!
renderViewSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer mcPatch: self.
	aTOTabSpec renderer renderContentOn: html main: main! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 12:29'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		rendererClass: TOPatchList;
		receiver: self;
		label: 'changes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderViewSidebarOn:spec:tOdeMain:)}! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 11:25'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		rendererClass: TOPatch;  
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		sidebarSpec: self tODEViewSidebarSpec;
		renderSelector: #renderViewContentOn:spec:main:! !
